bunch of minor updates
[automated-distro-installer] / myfai-chboot-local
index b2df864f129e32cbb2a1fdc5202192c115956b5d..1845cd02d58c6c98114f3eaf4987e01cb1e699e3 100755 (executable)
@@ -1,82 +1,97 @@
 #!/bin/bash
-
 # note, this script gets piped to bash, so cant cd to current dir
+
+[[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
+
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-
-fai_action_arg=I
+kgped16=false
+fai_action=install
 fai_reboot_arg=,reboot
-case $1 in
+while [[ $1 == -* ]]; do
+  case $1 in
     -h|--help)
-        echo "see help from myfai-chboot"
-        exit 0
-        ;;
+      echo "see help from myfai-chboot"
+      exit 0
+      ;;
     -S)
-        fai_action_arg=S
-        fai_reboot_arg=
-        shift
-        ;;
-esac
-
-[[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
+      fai_action=sysinfo
+      fai_reboot_arg=
+      shift
+      ;;
+    -i) #inventory
+      fai_action=inventory
+      fai_reboot_arg=
+      shift
+      ;;
+    -k)
+      kgped16=true;
+      shift
+      ;;
+  esac
+done
 
-e() {
-    echo "$*"
-    if ! "$@"; then
-        echo "$0: error: exit code $? from: $*"
-        exit 1
-    fi
-}
+pre="${0##*/}:"
+m() { printf "$pre %s\n"  "$*"; "$@"; }
+e() { printf "$pre %s\n"  "$*"; }
+err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $pre: $*" >&2; }
 
 host=$1
 
+rm -f /srv/tftp/fai/pxelinux.cfg/*
+if [[ ! $1 ]]; then
+  echo "$0: clearing pxe config and exiting"
+  exit 0
+fi
+
 # assuming ipv4, or else we might need to deal with multiple addresses
 # in an ipv4 + ipv6 network.
 my_ip=$(ip -4 route get 8.8.8.8 | sed -nr 's,^.*src\s+(\S+).*,\1,p')
 if [[ ! $my_ip || $my_ip =~ [[:space:]] ]]; then
-    echo "$0: error: failed to get \$my_ip, got: $my_ip"
-    exit 1
+  echo "$0: error: failed to get \$my_ip, got: $my_ip"
+  exit 1
 fi
 
 if [[ $host == default ]]; then
-    ip='*'
+  ip='*'
 elif [[ $host == [0-9]*.[0-9]*.[0-9]*.[0-9]* ]]; then
-    ip=$host/32
+  ip=$host/32
 else
-    type -t host &>/dev/null || apt-get -y install dnsutils
-    ip=$(host $host | sed -rn 's/^\S+ has address //p;T;q')/32
-    if [[ ! $ip || $ip =~ [[:space:]] ]]; then
-        echo "$0: error: failed to get \$my_ip, got: $my_ip"
-        exit 1
-    fi
-
+  type -t host &>/dev/null || apt-get -y install dnsutils
+  ip=$(host $host | sed -rn 's/^\S+ has address //p;T;q' ||:)
+  if [[ ! $ip || $ip =~ [[:space:]] ]]; then
+    echo "$0: error: failed to get \$ip, got: $ip"
+    exit 1
+  fi
+  ip=$ip/32
+  echo "$0: found ip of $host: $ip"
 fi
 
 if modprobe nfsd &>/dev/null; then
-    std_arg="-u nfs://faiserver/srv/fai/config"
-    # nfsv4 wont do rw with overlayfs yet
-    # https://lists.uni-koeln.de/pipermail/linux-fai/2017-March/011641.html
-    root_arg="$my_ip:/srv/fai/nfsroot:vers=3"
-    # fai-setup without -e sets the ip to the local_ip/local_network, eg 192.168.1.3/24
-    # I restrict it to one ip as simple but imperfect access control.
-
-    # we may chattr +i /etc/exports if we dun want it modified
-    # for example, if we made these exports more widely available
-    # while doing multiple installs or a recovery.
-    if [[ -w /etc/exports ]]; then
-        sed -ri --follow-symlinks '\%^/srv/fai/%d' /etc/exports
-        cat >>/etc/exports <<EOF
-/srv/fai/config $ip(async,ro,no_subtree_check)
+  std_arg="-u nfs://faiserver/srv/fai/config"
+  # nfsv4 wont do rw with overlayfs yet
+  # https://lists.uni-koeln.de/pipermail/linux-fai/2017-March/011641.html
+  root_arg="$my_ip:/srv/fai/nfsroot:vers=3"
+  # fai-setup without -e sets the ip to the local_ip/local_network, eg 192.168.1.3/24
+  # I restrict it to one ip as simple but imperfect access control.
+
+  # we may chattr +i /etc/exports if we dun want it modified
+  # for example, if we made these exports more widely available
+  # while doing multiple installs or a recovery.
+  if [[ -w /etc/exports ]]; then
+    sed -ri --follow-symlinks '\%^/srv/fai/%d' /etc/exports
+    cat >>/etc/exports <<EOF
+/srv/fai/config $ip(async,ro,no_subtree_check,no_root_squash)
 /srv/fai/nfsroot $ip(async,ro,no_subtree_check,no_root_squash)
 EOF
-        exportfs -ra
-    fi
-    systemctl start nfs-server # assumes recent os
+    exportfs -ra
+  fi
+  systemctl start nfs-server # assumes recent os
 else
-    std_arg="-u http://faiserver:8080/config.tar.gz"
-    root_arg="live:http://faiserver:8080/squash.img"
-    /a/exe/web-conf -i -p 8080 - apache2 faiserver <<EOF
+  std_arg="-u http://faiserver:8080/config.tar.gz"
+  root_arg="live:http://faiserver:8080/squash.img"
+  /a/exe/web-conf -i -p 8080 - apache2 faiserver <<EOF
 <Location />
     Deny from all
     Allow from $ip
@@ -84,28 +99,32 @@ else
 EOF
 fi
 
-rm -f /srv/tftp/fai/pxelinux.cfg/*
-if [[ ! $1 ]]; then
-    exit 0
-fi
 
 
 # man page doesn't explain this, but this deletes & thus disables
 # all chboot systems.
-e fai-chboot -${fai_action_arg}v $std_arg default # set it to default to get a val out of it next
+m fai-chboot -iv $std_arg default # set it to default to get a val out of it next
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 default_k_args=$(fai-chboot -L '^default$' | \
-                     sed -r "s/^(\S+\s+){3}(.*)/\2/")
+                   sed -r "s/^(\S+\s+){3}(.*)/\2/")
 # example of default_k_args
 # initrd=initrd.img-3.16.0-4-amd64 ip=dhcp root=192.168.1.3:/srv/fai/nfsroot aufs FAI_CONFIG_SRC=nfs://faiserver/srv/fai/config FAI_ACTION=install
 
-k_args=()
+k_args=(FAI_ACTION=$fai_action)
+if $kgped16; then
+  k_args+=(console=tty0 console=ttyS0,115200)
+fi
+
 for arg in $default_k_args; do
-    case $arg in
-        # default root arg is /srv/fai/nfsroot
-        root=*) k_args+=(root=$root_arg) ;;
-        *) k_args+=($arg) ;;
-    esac
+  case $arg in
+    # default root arg is /srv/fai/nfsroot
+    root=*) k_args+=(root=$root_arg) ;;
+    *) k_args+=($arg) ;;
+  esac
 done
 rm -f /srv/tftp/fai/pxelinux.cfg/*
-e fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
+m fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
+
+# this is needed for autodiscover iso. i'm not sure, it might override
+# the fai-chboot method of setting this, i'm not sure.
+echo FAI_ACTION=$fai_action >> /srv/fai/config/class/LAST.var